osmium Namespace Reference

Namespace for everything in the Osmium library. More...

## Namespaces

| area
| Code related to the building of areas (multipolygons) from relations.
| builder
| Classes for building OSM objects and other items in buffers.
| config
| diff_handler
| Osmium diff handlers provide access to differences between OSM object versions.
| experimental
| Experimental code that is not "officially" supported.
| geom
| Everything related to geometry handling.
| handler
| Osmium handlers provide callbacks for OSM objects.
| index
| Indexing of OSM data, Locations, etc.
| io
| Everything related to input and output of OSM data.
| memory
| Memory management of items in buffers and iterators over this data.
| osm_entity_bits
| Bitfield for OSM entity types.
| relations
| Code related to the assembly of OSM relations.
| tags
| Code related to working with OSM tags.
| thread
| Threading-related low-level code.
| util
| Helpful utility classes and functions not strictly OSM related.

## Classes

struct | are_real_integers
class | Area
class | Box
struct | buffer_is_full
struct | bzip2_error
class | Changeset
| An OSM Changeset, a group of changes made by a single user over a short period of time. More...
class | ChangesetComment
class | ChangesetDiscussion
class | CRC
class | DiffIterator
class | DiffObject
class | DiffObjectDerived
class | geometry_error
struct | geos_geometry_error
struct | gzip_error
class | InnerRing
struct | invalid_location
struct | io_error
class | Location
struct | location_equal
struct | location_less
class | max_op
class | MemoryUsage
class | min_op
class | Node
class | NodeRef
class | NodeRefList
struct | not_found
struct | object_equal_type_id
struct | object_equal_type_id_version
struct | object_order_type_id_reverse_version
struct | object_order_type_id_version
class | ObjectPointerCollection
class | OSMEntity
| OSMEntity is the abstract base class for the OSMObject and Changeset classes. More...
class | OSMObject
struct | out_of_order_error
class | OuterRing
struct | projection_error
class | Relation
class | RelationMember
class | RelationMemberList
class | Segment
class | Tag
class | TagList
class | Timestamp
class | UndirectedSegment
struct | unknown_type
struct | unsupported_file_format_error
class | Way
class | WayNodeList

## Typedefs

using | DiffNode = DiffObjectDerived< osmium::Node >
using | DiffWay = DiffObjectDerived< osmium::Way >
using | DiffRelation = DiffObjectDerived< osmium::Relation >
typedef int64_t | object_id_type
| Type for OSM object (node, way, or relation) IDs. More...
typedef uint64_t | unsigned_object_id_type
| Type for OSM object (node, way, or relation) IDs where we only allow positive IDs. More...
typedef uint32_t | object_version_type
| Type for OSM object version number. More...
typedef uint32_t | changeset_id_type
| Type for OSM changeset IDs. More...
typedef uint32_t | user_id_type
| Type for OSM user IDs. More...
typedef int32_t | signed_user_id_type
| Type for signed OSM user IDs. More...
typedef uint32_t | num_changes_type
| Type for changeset num_changes. More...
typedef uint32_t | num_comments_type
| Type for changeset num_comments. More...
typedef uint16_t | string_size_type

## Enumerations

enum

item_type : uint16_t {
item_type::undefined = 0x00, item_type::node = 0x01, item_type::way = 0x02, item_type::relation = 0x03,
item_type::area = 0x04, item_type::changeset = 0x05, item_type::tag_list = 0x11, item_type::way_node_list = 0x12,
item_type::relation_member_list = 0x13, item_type::relation_member_list_with_full_members = 0x23, item_type::outer_ring = 0x40, item_type::inner_ring = 0x41,
item_type::changeset_discussion = 0x80
}

## Functions

constexpr | _timestamp (const osmium::Timestamp &value) noexcept
constexpr | _timestamp (time_t value) noexcept
constexpr | _timestamp (uint32_t value) noexcept
| _timestamp (const char *value)
| _timestamp (const std::string &value)
template<typename TBasicIterator >
DiffIterator< TBasicIterator > | make_diff_iterator (TBasicIterator begin, TBasicIterator end)
template<typename TIterator , typename... THandlers>
void | apply_diff (TIterator it, TIterator end, THandlers &...handlers)
template<typename TSource , typename... THandlers>
void | apply_diff (TSource &source, THandlers &...handlers)
template<typename... THandlers>
void | apply_diff (osmium::memory::Buffer &buffer, THandlers &...handlers)
template<typename... THandlers>
void | apply_diff (const osmium::memory::Buffer &buffer, THandlers &...handlers)
osmium::object_id_type | object_id_to_area_id (osmium::object_id_type id, osmium::item_type type) noexcept
osmium::object_id_type | area_id_to_object_id (osmium::object_id_type id) noexcept
constexpr bool | operator== (const Box &lhs, const Box &rhs) noexcept
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const osmium::Box &box)
bool | operator== (const Changeset &lhs, const Changeset &rhs)
bool | operator!= (const Changeset &lhs, const Changeset &rhs)
bool | operator< (const Changeset &lhs, const Changeset &rhs)
bool | operator> (const Changeset &lhs, const Changeset &rhs)
bool | operator<= (const Changeset &lhs, const Changeset &rhs)
bool | operator>= (const Changeset &lhs, const Changeset &rhs)
item_type | nwr_index_to_item_type (unsigned int i) noexcept
unsigned int | item_type_to_nwr_index (item_type type) noexcept
item_type | char_to_item_type (const char c) noexcept
char | item_type_to_char (const item_type type) noexcept
const char * | item_type_to_name (const item_type type) noexcept
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const item_type item_type)
constexpr bool | operator== (const Location &lhs, const Location &rhs) noexcept
constexpr bool | operator!= (const Location &lhs, const Location &rhs) noexcept
constexpr bool | operator< (const Location &lhs, const Location &rhs) noexcept
constexpr bool | operator> (const Location &lhs, const Location &rhs) noexcept
constexpr bool | operator<= (const Location &lhs, const Location &rhs) noexcept
constexpr bool | operator>= (const Location &lhs, const Location &rhs) noexcept
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const osmium::Location &location)
constexpr bool | operator== (const NodeRef &lhs, const NodeRef &rhs) noexcept
constexpr bool | operator!= (const NodeRef &lhs, const NodeRef &rhs) noexcept
constexpr bool | operator< (const NodeRef &lhs, const NodeRef &rhs) noexcept
constexpr bool | operator> (const NodeRef &lhs, const NodeRef &rhs) noexcept
constexpr bool | operator<= (const NodeRef &lhs, const NodeRef &rhs) noexcept
constexpr bool | operator>= (const NodeRef &lhs, const NodeRef &rhs) noexcept
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const osmium::NodeRef &nr)
bool | operator== (const OSMObject &lhs, const OSMObject &rhs) noexcept
bool | operator!= (const OSMObject &lhs, const OSMObject &rhs) noexcept
bool | operator< (const OSMObject &lhs, const OSMObject &rhs) noexcept
bool | operator> (const OSMObject &lhs, const OSMObject &rhs) noexcept
bool | operator<= (const OSMObject &lhs, const OSMObject &rhs) noexcept
bool | operator>= (const OSMObject &lhs, const OSMObject &rhs) noexcept
constexpr bool | operator== (const Segment &lhs, const Segment &rhs) noexcept
| Segments are equal if both their locations are equal. More...
constexpr bool | operator!= (const Segment &lhs, const Segment &rhs) noexcept
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const osmium::Segment &segment)
bool | operator== (const Tag &a, const Tag &b)
bool | operator< (const Tag &a, const Tag &b)
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const Tag &tag)
constexpr Timestamp | start_of_time () noexcept
constexpr Timestamp | end_of_time () noexcept
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, Timestamp timestamp)
bool | operator== (const Timestamp &lhs, const Timestamp &rhs) noexcept
bool | operator!= (const Timestamp &lhs, const Timestamp &rhs) noexcept
bool | operator< (const Timestamp &lhs, const Timestamp &rhs) noexcept
bool | operator> (const Timestamp &lhs, const Timestamp &rhs) noexcept
bool | operator<= (const Timestamp &lhs, const Timestamp &rhs) noexcept
bool | operator>= (const Timestamp &lhs, const Timestamp &rhs) noexcept
template<>
osmium::Timestamp | min_op_start_value< osmium::Timestamp > ()
template<>
osmium::Timestamp | max_op_start_value< osmium::Timestamp > ()
object_id_type | string_to_object_id (const char *input)
std::pair< osmium::item_type, osmium::object_id_type > | string_to_object_id (const char *input, osmium::osm_entity_bits::type types)
object_version_type | string_to_object_version (const char *input)
changeset_id_type | string_to_changeset_id (const char *input)
signed_user_id_type | string_to_user_id (const char *input)
num_changes_type | string_to_num_changes (const char *input)
num_comments_type | string_to_num_comments (const char *input)
bool | operator< (const UndirectedSegment &lhs, const UndirectedSegment &rhs) noexcept
bool | operator> (const UndirectedSegment &lhs, const UndirectedSegment &rhs) noexcept
bool | operator<= (const UndirectedSegment &lhs, const UndirectedSegment &rhs) noexcept
bool | operator>= (const UndirectedSegment &lhs, const UndirectedSegment &rhs) noexcept
template<typename TChar , typename TTraits >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const osmium::UndirectedSegment &segment)
template<typename T , typename F , typename std::enable_if< are_real_integers< T, F >::value &&std::is_same< T, F >::value, int >::type = 0>
T | static_cast_with_assert (const F value)
template<typename T , typename F >
T | static_cast_with_assert (const F value)
template<typename T >
T | min_op_start_value ()
template<typename T >
T | max_op_start_value ()
std::vector< std::string > | split_string (const std::string &str, const char sep, bool compact=false)
std::vector< std::string > | split_string (const std::string &str, const char *sep, bool compact=false)
template<typename... THandlers>
void | apply_item (const osmium::memory::Item &item, THandlers &...handlers)
template<typename... THandlers>
void | apply_item (osmium::memory::Item &item, THandlers &...handlers)
template<typename TIterator , typename... THandlers>
void | apply (TIterator it, TIterator end, THandlers &...handlers)
template<typename TContainer , typename... THandlers>
void | apply (TContainer &c, THandlers &...handlers)
template<typename... THandlers>
void | apply (const osmium::memory::Buffer &buffer, THandlers &...handlers)

## Variables

constexpr const int | max_osm_string_length = 256 * 4

## Detailed Description

Namespace for everything in the Osmium library.

## Typedef Documentation

typedef uint32_t osmium::changeset_id_type

Type for OSM changeset IDs.

using osmium::DiffNode = typedef DiffObjectDerived<osmium::Node>

using osmium::DiffRelation = typedef DiffObjectDerived<osmium::Relation>

using osmium::DiffWay = typedef DiffObjectDerived<osmium::Way>

typedef uint32_t osmium::num_changes_type

Type for changeset num_changes.

typedef uint32_t osmium::num_comments_type

Type for changeset num_comments.

typedef int64_t osmium::object_id_type

Type for OSM object (node, way, or relation) IDs.

typedef uint32_t osmium::object_version_type

Type for OSM object version number.

typedef int32_t osmium::signed_user_id_type

Type for signed OSM user IDs.

typedef uint16_t osmium::string_size_type

Size for strings in OSM data such as user names, tag keys, roles, etc. In Osmium they can be up to 2^16 bytes long, but OSM usually has lower defined limits.

typedef uint64_t osmium::unsigned_object_id_type

Type for OSM object (node, way, or relation) IDs where we only allow positive IDs.

typedef uint32_t osmium::user_id_type

Type for OSM user IDs.

## Enumeration Type Documentation

enum osmium::item_type : uint16_t

strong

Enumerator
undefined |
node |
way |
relation |
area |
changeset |
tag_list |
way_node_list |
relation_member_list |
relation_member_list_with_full_members |
outer_ring |
inner_ring |
changeset_discussion |

## Function Documentation

constexpr osmium::_timestamp | ( | const osmium::Timestamp & | value | ) |

explicit noexcept

constexpr osmium::_timestamp | ( | time_t | value | ) |

explicit noexcept

constexpr osmium::_timestamp | ( | uint32_t | value | ) |

explicit noexcept

osmium::_timestamp | ( | const char * | value | ) |

explicit

osmium::_timestamp | ( | const std::string & | value | ) |

explicit

template<typename TIterator , typename... THandlers>

void osmium::apply | ( | TIterator | it,
|  | TIterator | end,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename TContainer , typename... THandlers>

void osmium::apply | ( | TContainer & | c,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename... THandlers>

void osmium::apply | ( | const osmium::memory::Buffer & | buffer,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename TIterator , typename... THandlers>

void osmium::apply_diff | ( | TIterator | it,
|  | TIterator | end,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename TSource , typename... THandlers>

void osmium::apply_diff | ( | TSource & | source,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename... THandlers>

void osmium::apply_diff | ( | osmium::memory::Buffer & | buffer,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename... THandlers>

void osmium::apply_diff | ( | const osmium::memory::Buffer & | buffer,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename... THandlers>

void osmium::apply_item | ( | const osmium::memory::Item & | item,
|  | THandlers &... | handlers
| ) |  |

inline

template<typename... THandlers>

void osmium::apply_item | ( | osmium::memory::Item & | item,
|  | THandlers &... | handlers
| ) |  |

inline

osmium::object_id_type osmium::area_id_to_object_id | ( | osmium::object_id_type | id | ) |

inline noexcept

Convert area id into id of the way or relation it was created from.

Parameters

  id | Area id

Returns
  Way or Relation id.

item_type osmium::char_to_item_type | ( | const char | c | ) |

inline noexcept

constexpr Timestamp osmium::end_of_time | ( |  | ) |

inline noexcept

A special Timestamp guaranteed to be ordered after any other valid Timestamp.

char osmium::item_type_to_char | ( | const item_type | type | ) |

inline noexcept

const char* osmium::item_type_to_name | ( | const item_type | type | ) |

inline noexcept

unsigned int osmium::item_type_to_nwr_index | ( | item_type | type | ) |

inline noexcept

Return index for item_type: node -> 0, way -> 1, relation -> 2

Parameters

  type | Item type. Must be node, way, or relation.

Returns
  Index.

template<typename TBasicIterator >

DiffIterator<TBasicIterator> osmium::make_diff_iterator | ( | TBasicIterator | begin,
|  | TBasicIterator | end
| ) |  |

inline

Create a DiffIterator based on the given iterators.

template<typename T >

T osmium::max_op_start_value | ( |  | ) |

inline

template<>

osmium::Timestamp osmium::max_op_start_value< osmium::Timestamp > | ( |  | ) |

inline

template<typename T >

T osmium::min_op_start_value | ( |  | ) |

inline

template<>

osmium::Timestamp osmium::min_op_start_value< osmium::Timestamp > | ( |  | ) |

inline

item_type osmium::nwr_index_to_item_type | ( | unsigned int | i | ) |

inline noexcept

Return item_type for index: 0 -> node, 1 -> way, 2 -> relation

Parameters

  i | Index. Must be between 0 and 2.

Returns
  Item type.

osmium::object_id_type osmium::object_id_to_area_id | ( | osmium::object_id_type | id,
|  | osmium::item_type | type
| ) |  |

inline noexcept

Convert way or (multipolygon) relation id into unique area id.

Parameters

  id | Id of a way or relation
  type | Type of object (way or relation)

Returns
  Area id

constexpr bool osmium::operator!= | ( | const Segment & | lhs,
|  | const Segment & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator!= | ( | const NodeRef & | lhs,
|  | const NodeRef & | rhs
| ) |  |

inline noexcept

Compare two NodeRefs. They are not equal if they reference different Node IDs.

bool osmium::operator!= | ( | const Timestamp & | lhs,
|  | const Timestamp & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator!= | ( | const Location & | lhs,
|  | const Location & | rhs
| ) |  |

inline noexcept

bool osmium::operator!= | ( | const OSMObject & | lhs,
|  | const OSMObject & | rhs
| ) |  |

inline noexcept

bool osmium::operator!= | ( | const Changeset & | lhs,
|  | const Changeset & | rhs
| ) |  |

inline

bool osmium::operator< | ( | const UndirectedSegment & | lhs,
|  | const UndirectedSegment & | rhs
| ) |  |

inline noexcept

UndirectedSegments are "smaller" if they are to the left and down of another segment. The first() location is checked first() and only if they have the same first() location the second() location is taken into account.

bool osmium::operator< | ( | const Tag & | a,
|  | const Tag & | b
| ) |  |

inline

constexpr bool osmium::operator< | ( | const NodeRef & | lhs,
|  | const NodeRef & | rhs
| ) |  |

inline noexcept

Compare two NodeRefs. NodeRefs are ordered according to the Node ID they reference.

bool osmium::operator< | ( | const Timestamp & | lhs,
|  | const Timestamp & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator< | ( | const Location & | lhs,
|  | const Location & | rhs
| ) |  |

inline noexcept

Compare two locations by comparing first the x and then the y coordinate. If either of the locations is undefined the result is undefined.

bool osmium::operator< | ( | const OSMObject & | lhs,
|  | const OSMObject & | rhs
| ) |  |

inline noexcept

OSMObjects can be ordered by type, id and version. Note that we use the absolute value of the id for a better ordering of objects with negative id.

bool osmium::operator< | ( | const Changeset & | lhs,
|  | const Changeset & | rhs
| ) |  |

inline

Changesets can be ordered by id.

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const osmium::UndirectedSegment & | segment
| ) |  |

inline

Output UndirectedSegment to a stream.

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const osmium::Segment & | segment
| ) |  |

inline

Output Segment to a stream.

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const Tag & | tag
| ) |  |

inline

Output a Tag to a stream.

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const item_type | item_type
| ) |  |

inline

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const osmium::NodeRef & | nr
| ) |  |

inline

Output a NodeRef to a stream.

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const osmium::Box & | box
| ) |  |

inline

Output a box to a stream. The format is "(LON, LAT, LON, LAT)" or "(undefined)" if the box is undefined.

Returns
  Reference to basic_ostream given as first parameter.

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | Timestamp | timestamp
| ) |  |

inline

template<typename TChar , typename TTraits >

std::basic_ostream<TChar, TTraits>& osmium::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const osmium::Location & | location
| ) |  |

inline

Output a location to a stream.

bool osmium::operator<= | ( | const UndirectedSegment & | lhs,
|  | const UndirectedSegment & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator<= | ( | const NodeRef & | lhs,
|  | const NodeRef & | rhs
| ) |  |

inline noexcept

Compare two NodeRefs. NodeRefs are ordered according to the Node ID they reference.

bool osmium::operator<= | ( | const Timestamp & | lhs,
|  | const Timestamp & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator<= | ( | const Location & | lhs,
|  | const Location & | rhs
| ) |  |

inline noexcept

bool osmium::operator<= | ( | const OSMObject & | lhs,
|  | const OSMObject & | rhs
| ) |  |

inline noexcept

bool osmium::operator<= | ( | const Changeset & | lhs,
|  | const Changeset & | rhs
| ) |  |

inline

constexpr bool osmium::operator== | ( | const Segment & | lhs,
|  | const Segment & | rhs
| ) |  |

inline noexcept

Segments are equal if both their locations are equal.

bool osmium::operator== | ( | const Tag & | a,
|  | const Tag & | b
| ) |  |

inline

constexpr bool osmium::operator== | ( | const NodeRef & | lhs,
|  | const NodeRef & | rhs
| ) |  |

inline noexcept

Compare two NodeRefs. They are equal if they reference the same Node ID.

constexpr bool osmium::operator== | ( | const Box & | lhs,
|  | const Box & | rhs
| ) |  |

inline noexcept

Boxes are equal if both locations are equal. Undefined boxes will compare equal.

bool osmium::operator== | ( | const Timestamp & | lhs,
|  | const Timestamp & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator== | ( | const Location & | lhs,
|  | const Location & | rhs
| ) |  |

inline noexcept

Locations are equal if both coordinates are equal.

bool osmium::operator== | ( | const OSMObject & | lhs,
|  | const OSMObject & | rhs
| ) |  |

inline noexcept

OSMObjects are equal if their type, id, and version are equal.

bool osmium::operator== | ( | const Changeset & | lhs,
|  | const Changeset & | rhs
| ) |  |

inline

Changesets are equal if their IDs are equal.

bool osmium::operator> | ( | const UndirectedSegment & | lhs,
|  | const UndirectedSegment & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator> | ( | const NodeRef & | lhs,
|  | const NodeRef & | rhs
| ) |  |

inline noexcept

Compare two NodeRefs. NodeRefs are ordered according to the Node ID they reference.

bool osmium::operator> | ( | const Timestamp & | lhs,
|  | const Timestamp & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator> | ( | const Location & | lhs,
|  | const Location & | rhs
| ) |  |

inline noexcept

bool osmium::operator> | ( | const OSMObject & | lhs,
|  | const OSMObject & | rhs
| ) |  |

inline noexcept

bool osmium::operator> | ( | const Changeset & | lhs,
|  | const Changeset & | rhs
| ) |  |

inline

bool osmium::operator>= | ( | const UndirectedSegment & | lhs,
|  | const UndirectedSegment & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator>= | ( | const NodeRef & | lhs,
|  | const NodeRef & | rhs
| ) |  |

inline noexcept

Compare two NodeRefs. NodeRefs are ordered according to the Node ID they reference.

bool osmium::operator>= | ( | const Timestamp & | lhs,
|  | const Timestamp & | rhs
| ) |  |

inline noexcept

constexpr bool osmium::operator>= | ( | const Location & | lhs,
|  | const Location & | rhs
| ) |  |

inline noexcept

bool osmium::operator>= | ( | const OSMObject & | lhs,
|  | const OSMObject & | rhs
| ) |  |

inline noexcept

bool osmium::operator>= | ( | const Changeset & | lhs,
|  | const Changeset & | rhs
| ) |  |

inline

std::vector<std::string> osmium::split_string | ( | const std::string & | str,
|  | const char | sep,
|  | bool | compact = `false`
| ) |  |

inline

Split string on the separator character.

Parameters

  str | The string to be split.
  sep | The separator character.
  compact | Set this to true to remove empty strings from result

Returns
  Vector with the parts of the string split up.

std::vector<std::string> osmium::split_string | ( | const std::string & | str,
|  | const char * | sep,
|  | bool | compact = `false`
| ) |  |

inline

Split string on the separator character(s).

Parameters

  str | The string to be split.
  sep | The separator character(s).
  compact | Set this to true to remove empty strings from result

Returns
  Vector with the parts of the string split up.

constexpr Timestamp osmium::start_of_time | ( |  | ) |

inline noexcept

A special Timestamp guaranteed to be ordered before any other valid Timestamp.

template<typename T , typename F , typename std::enable_if< are_real_integers< T, F >::value &&std::is_same< T, F >::value, int >::type = 0>

T osmium::static_cast_with_assert | ( | const F | value | ) |

inline

template<typename T , typename F >

T osmium::static_cast_with_assert | ( | const F | value | ) |

inline

changeset_id_type osmium::string_to_changeset_id | ( | const char * | input | ) |

inline

Convert string with object version to object_version_type.

Precondition
  input must not be nullptr.

Parameters

  input | Input string.

Exceptions

  std::range_error | if the value is out of range.

num_changes_type osmium::string_to_num_changes | ( | const char * | input | ) |

inline

Convert string with number of changes to num_changes_type.

Precondition
  input must not be nullptr.

Parameters

  input | Input string.

Exceptions

  std::range_error | if the value is out of range.

num_comments_type osmium::string_to_num_comments | ( | const char * | input | ) |

inline

Convert string with number of comments to num_comments_type.

Precondition
  input must not be nullptr.

Parameters

  input | Input string.

Exceptions

  std::range_error | if the value is out of range.

object_id_type osmium::string_to_object_id | ( | const char * | input | ) |

inline

Convert string with object id to object_id_type.

Precondition
  input must not be nullptr.

Parameters

  input | Input string.

Exceptions

  std::range_error | if the value is out of range.

std::pair<osmium::item_type, osmium::object_id_type> osmium::string_to_object_id | ( | const char * | input,
|  | osmium::osm_entity_bits::type | types
| ) |  |

inline

Parse string with object type identifier followed by object id. This reads strings like "n1234" and "w10".

Precondition
  input must not be nullptr.

Parameters

  input | Input string.
  types | Allowed types. Must not be osmium::osm_entity_bits::nothing.

Returns
  std::pair of type and id.

Exceptions

  std::range_error | if the value is out of range.

object_version_type osmium::string_to_object_version | ( | const char * | input | ) |

inline

Convert string with object version to object_version_type.

Precondition
  input must not be nullptr.

Parameters

  input | Input string.

Exceptions

  std::range_error | if the value is out of range.

signed_user_id_type osmium::string_to_user_id | ( | const char * | input | ) |

inline

Convert string with user id to signed_user_id_type.

Precondition
  input must not be nullptr.

Parameters

  input | Input string.

Exceptions

  std::range_error | if the value is out of range.

## Variable Documentation

constexpr const int osmium::max_osm_string_length = 256 * 4